uniform mat4 uMVPMatrix; //ܱ任
uniform mat4 uMMatrix; //任
uniform vec3 uCamera;	//λ
uniform vec3 uLightLocationRed;	//ɫԴλ
attribute vec3 aPosition;  //λ
attribute vec4 aColor;    //ɫ
varying  vec4 aaColor;//ɫƬɫ 
attribute vec3 aNormal;    //
varying vec4 ambient;
varying vec4 diffuse;
varying vec4 specular;

//λռķ
void pointLight(					//λռķ
  in vec3 normal,				//
  inout vec4 ambient,			//ǿ
  inout vec4 diffuse,				//ɢǿ
  inout vec4 specular,			//ǿ
  in vec3 lightLocation,			//Դλ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 normalTarget=aPosition+normal;	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(aPosition,1)).xyz;
  newNormal=normalize(newNormal); 	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*vec4(aPosition,1)).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*vec4(aPosition,1)).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=50.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}

void main()     
{                            		
   gl_Position = uMVPMatrix * vec4(aPosition,1); //ܱ任˴λƴ˶λ     
   pointLight(normalize(aNormal),ambient,diffuse,specular,uLightLocationRed,
   vec4(0.1,0.1,0.1,1.0),vec4(0.5,0.5,0.5,1.0),vec4(0.6,0.6,0.6,1.0));
}                 